package it.uniroma1.dis.jasmine.ui.utils;

import java.util.StringTokenizer;
import java.util.Vector;

public class NuSMVOutputParser {
	public static Vector<NuSMVVariableData> parseTestCase(String smvString){
		
		//splitto la stringa con separatore "-> State: 1."	
		String[] arrString = smvString.split("-> State: 1.");

		//devo saltare il primo token perche'  quello della parte iniziale dell'out
		int count=1;
		
		//ad ogni token ho un nuovo stato
		
		//se lo stato e' il primo costruisco tutti gli elementi del Vector di tipo VarData, altrimenti copio dalla precedente e cambio solo quelle diverse
		String actualToken = arrString[count];
		
						
		//costruisco un nuovo tokenizer con delimitatore "\n" su actualToken
		StringTokenizer auxTok = new StringTokenizer(actualToken, "\n");
		
		//anche qui devo saltare il primo token
		auxTok.nextToken();
		
		//struttura dati che conterrà le info sulle variabili dell'istanta corrente
		Vector<NuSMVVariableData> tempVect = new Vector<NuSMVVariableData>(20, 20);
		
		while(auxTok.hasMoreTokens()){
			String varToken = auxTok.nextToken().trim();
			
			if(!varToken.startsWith("->") && !(varToken.startsWith("--"))){					
				//ora ho bisogno di un tokenizer con delimitatore "="
				StringTokenizer varTok = new StringTokenizer(varToken, "=");
				
				//il primo token sara' la variabile e l'altro il valore
				NuSMVVariableData tempVarData = new NuSMVVariableData();
				tempVarData.setVarName(varTok.nextToken().trim());
				
				//non si considerano le variabili non utili ai fini del caso di test
				if(tempVarData.getVarName().contains("PC")
						|| tempVarData.getVarName().contains("PRE")
						||tempVarData.getVarName().contains("POST")
						||tempVarData.getVarName().contains("TERM"))
					continue;
				
				//devo convertire in intero il token che contiene il valore della variabile
				Integer varValue = new Integer(varTok.nextToken().trim());
				tempVarData.setVarValue(varValue);
				
				//aggiungo la struttura dati al vector dell'istante corrente
				tempVect.add(tempVarData);
			}
								
		}
	
		
		return tempVect;
	}
	
	
	/*
	 * Metodo per la verifica della stringa da parsare: controlla se all'interno della stringa passata è presente lo statement "is false"
	 **/
	 
	 public static boolean checkSmvString(String smvString){
	 	boolean checkRes = false;
	 	
	 	if(smvString.contains("is false"))
	 		checkRes = true;
	 	
	 	return checkRes;
	 }
}
