package it.uniroma1.dis.jasmine.ui.utils;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Properties;

/**
 * Singleton.
 */
public class Settings extends Properties {
	/**
	 *
	 */
	public static enum SettingsEnum {
		lastJavaFile, nusmvLocation, nusmvParameters;
	}
	
	/**
	 * Generated.
	 */
	private static final long serialVersionUID = 6348667014134959833L;
	private static final Settings instance = new Settings();
	
	/**
	 * 
	 */
	private Settings() {
		super();
		loadSettings();
	}
	
	/**
	 * @return
	 */
	public static Settings getInstance() {
		return instance;
	}
	
	/**
	 * @param key
	 * @param value
	 * @return
	 */
	public boolean setSetting(SettingsEnum key, String value) {
		if (key == null)
			return false;
		
		super.setProperty(key.toString(), value);
		return true;
	}
	
	/**
	 * @param key
	 * @return
	 */
	public String getSetting(SettingsEnum key) {
		if (key == null)
			return null;
		else
			return super.getProperty(key.toString());
	}
	
	/**
	 * 
	 */
	public boolean storeSettings() {
		try {
			FileOutputStream fos = new FileOutputStream("settings.properties");
			store(fos, null);
			return true;
		} catch (Exception e) {
			System.err.println("[" + getClass().getName() + "]: " + e.getMessage());
			return false;
		}
	}
	
	/**
	 * @return
	 */
	public boolean loadSettings() {
		try {
			File f = new File("settings.properties");
			if (!f.exists())
				return false;
			
			FileInputStream fis = new FileInputStream(f);
			load(fis);
			return true;
		} catch (Exception e) {
			System.err.println("[" + getClass().getName() + "]: " + e.getMessage());
			return false;
		}
	}
}
