//
//Generated by JTB 1.2.2


package it.uniroma1.dis.jasmine.visitor;

import EDU.purdue.jtb.syntaxtree.Block;
import EDU.purdue.jtb.syntaxtree.BreakStatement;
import EDU.purdue.jtb.syntaxtree.ContinueStatement;
import EDU.purdue.jtb.syntaxtree.DoStatement;
import EDU.purdue.jtb.syntaxtree.ForStatement;
import EDU.purdue.jtb.syntaxtree.IfStatement;
import EDU.purdue.jtb.syntaxtree.LocalVariableDeclaration;
import EDU.purdue.jtb.syntaxtree.ReturnStatement;
import EDU.purdue.jtb.syntaxtree.StatementExpression;
import EDU.purdue.jtb.syntaxtree.SwitchStatement;
import EDU.purdue.jtb.syntaxtree.WhileStatement;
import EDU.purdue.jtb.visitor.DepthFirstVisitor;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */

//VISITOR CHE SE VIENE INVOCATO SU UN NODE DI TIPO IF_STATEMENT O WHILE_STATEMENT MEMORIZZA LA LUNGHEZZA NELLA VARIABILE DI ISTANZA length
public class LengthVisitor extends DepthFirstVisitor {
	private int length;

	/**
	 * 
	 */
	public LengthVisitor(){
		length=0;
	}

	/**
	 * @return the length
	 */
	public int getLength() {
		return length;
	}

	/* (non-Javadoc)
	 * @see EDU.purdue.jtb.visitor.Visitor#visit(EDU.purdue.jtb.syntaxtree.LocalVariableDeclaration)
	 */
	@Override
	public void visit(LocalVariableDeclaration n) {
		super.visit(n);

		this.length+=1;
	}

	/* (non-Javadoc)
	 * @see EDU.purdue.jtb.visitor.Visitor#visit(EDU.purdue.jtb.syntaxtree.LocalVariableDeclaration)
	 */
	@Override
	public void visit(StatementExpression n) {
		this.length +=1;
		super.visit(n);
	}

	/* (non-Javadoc)
	 * @see EDU.purdue.jtb.visitor.Visitor#visit(EDU.purdue.jtb.syntaxtree.LocalVariableDeclaration)
	 */
	@Override
	public void visit(IfStatement n) {
		this.length+=2;
		super.visit(n);
	}

	/* (non-Javadoc)
	 * @see EDU.purdue.jtb.visitor.Visitor#visit(EDU.purdue.jtb.syntaxtree.LocalVariableDeclaration)
	 */
	@Override
	public void visit(WhileStatement n) {
		this.length+=2;
		super.visit(n);
	}
	
	
	/* (non-Javadoc)
	 * @see EDU.purdue.jtb.visitor.Visitor#visit(EDU.purdue.jtb.syntaxtree.LocalVariableDeclaration)
	 */
	@Override
	public void visit(DoStatement n) {
		this.length+=1;
		super.visit(n);
	}

	/* (non-Javadoc)
	 * @see EDU.purdue.jtb.visitor.DepthFirstVisitor#visit(EDU.purdue.jtb.syntaxtree.Statement)
	 */
	@Override
	public void visit(Block n) {
//		this.length+=1;
		super.visit(n);
	}

	/* (non-Javadoc)
	 * @see EDU.purdue.jtb.visitor.Visitor#visit(EDU.purdue.jtb.syntaxtree.LocalVariableDeclaration)
	 */
	@Override
	public void visit(ForStatement n) {
		//this.length +=3;
		this.length +=2;
		super.visit(n);
	}
	
	/* (non-Javadoc)
	 * @see EDU.purdue.jtb.visitor.Visitor#visit(EDU.purdue.jtb.syntaxtree.LocalVariableDeclaration)
	 */
	@Override
	public void visit(SwitchStatement n) {
		//this.length +=3;
		this.length +=1;
		super.visit(n);
	}
	

	/* (non-Javadoc)
	 * @see EDU.purdue.jtb.visitor.Visitor#visit(EDU.purdue.jtb.syntaxtree.LocalVariableDeclaration)
	 */
	@Override
	public void visit(BreakStatement n) {
		this.length +=1;
		super.visit(n);
	}

	/* (non-Javadoc)
	 * @see EDU.purdue.jtb.visitor.Visitor#visit(EDU.purdue.jtb.syntaxtree.LocalVariableDeclaration)
	 */
	@Override
	public void visit(ContinueStatement n) {
		this.length +=1;
		super.visit(n);
	}

	/* (non-Javadoc)
	 * @see EDU.purdue.jtb.visitor.Visitor#visit(EDU.purdue.jtb.syntaxtree.LocalVariableDeclaration)
	 */
	@Override
	public void visit(ReturnStatement n) {
		this.length +=1;
		super.visit(n);
	}
}
