/**
 * Jasmine
 * 16/giu/08
 */
package it.uniroma1.dis.jasmine.visitor;

import it.uniroma1.dis.jasmine.MethodCall;

import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import EDU.purdue.jtb.syntaxtree.FormalParameter;
import EDU.purdue.jtb.syntaxtree.MethodDeclaration;
import EDU.purdue.jtb.syntaxtree.Node;
import EDU.purdue.jtb.syntaxtree.NodeListOptional;
import EDU.purdue.jtb.syntaxtree.NodeSequence;
import EDU.purdue.jtb.visitor.DepthFirstVisitor;

/**
 *
 */
public class MethodVisitor extends DepthFirstVisitor {
	private Set<MethodCall> methodSet;
	
	/**
	 * 
	 */
	public MethodVisitor() {
		super();
		this.methodSet = new HashSet<MethodCall>();
	}
	
	/**
	 * @return the methodSet
	 */
	public Set<MethodCall> getMethodSet() {
		return methodSet;
	}

	/* (non-Javadoc)
	 * @see EDU.purdue.jtb.visitor.DepthFirstVisitor#visit(EDU.purdue.jtb.syntaxtree.MethodDeclarator)
	 */
	@Override
	public void visit(MethodDeclaration n) {
		ImageVisitor img = new ImageVisitor();
		n.f1.accept(img);
		
		// method name and return value:
		MethodCall m = new MethodCall(n.f2.f0.tokenImage, img.getImage());
		
		// method parameters:
		List<String> paramList = new LinkedList<String>();
		if (n.f2.f1.f1.node instanceof NodeSequence) {
			paramList = parseFormalParameters(paramList, (NodeSequence)n.f2.f1.f1.node);
			for (String param : paramList)
				m.addDeclaredParameter(param);
		}
		
		this.methodSet.add(m);
	}
	
	/**
	 * @param paramList
	 * @param sequence
	 * @return
	 */
	private List<String> parseFormalParameters(List<String> paramList, NodeSequence sequence) {
		if ((sequence == null) || (sequence.nodes.size() == 0))
			return paramList;
		
		for (Node n : sequence.nodes) {
			if (n instanceof FormalParameter) {
				paramList.add(((FormalParameter)n).f2.f0.tokenImage);
			} else if (n instanceof NodeListOptional) {
				for (Node opt : ((NodeListOptional)n).nodes)
					if (opt instanceof NodeSequence)
						paramList.addAll(parseFormalParameters(paramList, (NodeSequence)opt));
			}
		}
		
		return paramList;
	}
}
